#include<bits/stdc++.h>
using namespace std;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n,k;
    cin>>n>>k;
    vector<int> a(n+1);
    for(int i=1;i<=n;i++) cin>>a[i];
    int ans=0;
    for(int j=30;j>=0;j--){
        int q=0,cnt=0;
        for(int i=1;i<=n;i++){
            q|=a[i];
            if(q&(1<<j)&&(q&ans)==ans){
                cnt++;
                q=0;
            }
        }
        if(cnt>=k) ans|=(1<<j);
    }
    cout<<ans;
}
